/*************************************************************************************************
*   ViewM3 v2.0.0 by therockman (uxorious.rockman@gmail.com)
*     
*   Structures are based on those posted by NiNtoxicated01 and witchsong at sc2mapster.com.
*
*	Files include: Types.hpp, M3.hpp, M3.cpp and Main.cpp
*
*   CHANGE LOG:
*       -- Moved TOC section to bottom
*       -- Reference links now directly jump to sections rather than TOC
*       -- Added HTML formatting to support CSS stylesheets
*       -- Appended a 'Vertices' section to the end of the MODL section
*       -- Added parsing for MODL-20
*       -- References of type CHAR are now resolved and rendered inline
*       -- Added hex dump formatting for unknown fields
*
*	To Run: 
		From the commandline supply a .m3 file as input name a .html file for output.
*		/> ViewM3 marine.m3 marine.m3.html
**************************************************************************************************/
#include "M3.hpp"
#include <fstream>
using namespace std;

int main(int argc, char* argv [])
{
	char* FilenameM3, *FilenameHTML;

	// check usage
	if(argc != 3){
		cerr << "Usage:\n\tViewM3 FileM3 FileHTML\n";
		exit(-1);
	}
	FilenameM3 = argv[1];
	FilenameHTML = argv[2];

	// open the input file for reading
	ifstream FileM3(FilenameM3, ios::binary);
	if(!FileM3){
		cerr << "Error: Could not open file '" << FilenameM3 << "'.\n";
		exit(-2);
	}
	
	// open the output file for writing
	ofstream FileHTML(FilenameHTML);
	if(!FileHTML){
		cerr << "Error: Could not open file '" << FilenameHTML << "'.\n";
		exit(-2);
	}

	M3::ConvertM3toHTML(FileM3, FileHTML);

	FileM3.close();
	FileHTML.close();
}