#pragma once
#include <iostream>

typedef unsigned int uint;
typedef unsigned char uint8;
typedef signed short int16;
typedef unsigned short uint16;
typedef unsigned long uint32;
typedef signed long int32;

struct Vector2f {float x, y;};
struct Vector3f {float x, y, z;};
typedef struct Vector4f {float x, y, z, w;} Quaternion4f;
typedef float Matrix16f [4][4];
struct Bounds7f {Vector3f v1, v2; float Radius;};

union type32
{
	char Tag [4];
	uint32 Value;
};

inline std::istream& operator >>(std::istream& In, type32& type){
	return In >> type.Tag[0] >> type.Tag[1] >> type.Tag[2] >> type.Tag[3];
}

inline std::ostream& operator <<(std::ostream& Out, const type32& type){
	return Out << type.Tag[0] << type.Tag[1] << type.Tag[2] << type.Tag[3];
}

union tag32
{
	char Tag [4];
	uint32 Value;
};

inline std::istream& operator >>(std::istream& In, tag32& tag){
	return In >> tag.Tag[3] >> tag.Tag[2] >> tag.Tag[1] >> tag.Tag[0];
}

inline std::ostream& operator <<(std::ostream& Out, const tag32& tag){
	return Out << tag.Tag[3] << tag.Tag[2] << tag.Tag[1] << tag.Tag[0];
}
